package com.citygis.server.manage.api;

import com.citygis.server.manage.api.dto.template.TemplateRequestDTO;
import com.citygis.server.manage.api.dto.template.TemplateResponseDTO;
import com.citygis.common.boot.struct.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import java.util.List;

@Api("template-api")
@RequestMapping("/api/template")
@FeignClient(name = "cimApi", url = "${services.template.url}")
public interface TemplateApi {
    /**
     * 根据ID集合获取资源集合
     * @return 编号
     */
    @ApiOperation("获取模板列表")
    @PostMapping("/list")
    Result<List<TemplateResponseDTO>> list(@RequestBody TemplateRequestDTO templateRequestDTO);
}
