package com.citygis.server.manage.domain;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.client.loadbalancer.LoadBalanced;
import org.springframework.context.annotation.Bean;
import org.springframework.web.client.RestTemplate;

@MapperScan(basePackages = "com.citygis.server.manage.domain.dao.db")
@SpringBootApplication(scanBasePackages = {
        "com.citygis.server.manage.domain",
        "com.citygis.common.boot"
})
@EnableDiscoveryClient
public class ServerManageApplication {

    public static void main(String[] args) {
        SpringApplication.run(ServerManageApplication.class, args);
    }

    @Bean
    @LoadBalanced
    RestTemplate restTemplate() {
        return new RestTemplate();
    }
}
