package com.citygis.server.manage.domain.repository;

import com.citygis.server.manage.domain.dao.db.TemplateMapper;
import com.citygis.server.manage.domain.dao.po.TemplatePO;
import com.citygis.server.manage.domain.entities.template.TemplateEntity;
import com.citygis.server.manage.domain.entities.template.TemplateQueryEntity;
import com.citygis.server.manage.domain.factory.mapper.TemplateFactoryMapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Repository;

import jakarta.annotation.Resource;
import java.util.List;

@Repository
public class TemplateRepository {
    @Resource
    private TemplateMapper templateMapper;

    public PageInfo<TemplatePO> pageList(TemplateQueryEntity templateQueryEntity){
        PageHelper.startPage(templateQueryEntity.getPageNum(),templateQueryEntity.getPageSize());
        List<TemplatePO> users = templateMapper.list(templateQueryEntity);
        PageInfo<TemplatePO> pageInfo = new PageInfo<>(users);
        return pageInfo;
    }

    public List<TemplateEntity> list(TemplateQueryEntity templateQueryEntity) {
        return TemplateFactoryMapper.INSTANCE.poToEntities(templateMapper.list(templateQueryEntity));
    }

    public TemplateEntity get(TemplateQueryEntity templateQueryEntity) {
        return TemplateFactoryMapper.INSTANCE.poToEntity(templateMapper.get(templateQueryEntity));
    }

    public Integer insert(TemplateEntity templateEntity) {
        TemplatePO templatePO = TemplateFactoryMapper.INSTANCE.entityToPo(templateEntity);
        return templateMapper.insert(templatePO);
    }

    public Integer modify(TemplateEntity templateEntity) {
        TemplatePO templatePO = TemplateFactoryMapper.INSTANCE.entityToPo(templateEntity);
        return templateMapper.modify(templatePO);
    }

    public Integer delete(Long id) {
        return templateMapper.delete(id);
    }
}
