package com.citygis.server.manage.domain.service.impl;

import com.citygis.server.manage.domain.entities.template.TemplateEntity;
import com.citygis.server.manage.domain.entities.template.TemplateQueryEntity;
import com.citygis.server.manage.domain.factory.mapper.TemplateFactoryMapper;
import com.citygis.server.manage.domain.controller.co.template.TemplateCO;
import com.citygis.server.manage.domain.controller.co.template.TemplateQueryCO;
import com.citygis.server.manage.domain.controller.vo.template.TemplateGetVO;
import com.citygis.server.manage.domain.controller.vo.template.TemplateListVO;
import com.citygis.server.manage.domain.dao.po.TemplatePO;
import com.citygis.server.manage.domain.repository.TemplateRepository;
import com.citygis.server.manage.domain.service.TemplateService;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Service;

import jakarta.annotation.Resource;
import java.util.List;

@Service
public class TemplateServiceImpl implements TemplateService {
    @Resource
    private TemplateRepository templateRepository;

    @Override
    public PageInfo<TemplatePO> pageTemplate(TemplateQueryCO co) {
        TemplateQueryEntity templateQueryEntity = TemplateFactoryMapper.INSTANCE.queryCOToQueryEntity(co);
        PageInfo<TemplatePO> pageIndo = templateRepository.pageList(templateQueryEntity);
        return pageIndo;
    }

    @Override
    public List<TemplateListVO> listTemplate(TemplateQueryCO co) {
        TemplateQueryEntity templateQueryEntity = TemplateFactoryMapper.INSTANCE.queryCOToQueryEntity(co);
        List<TemplateEntity> templateEntities = templateRepository.list(templateQueryEntity);
        List<TemplateListVO> templateVOList = TemplateFactoryMapper.INSTANCE.entitiesToListVOList(templateEntities);
        return templateVOList;
    }

    @Override
    public TemplateGetVO getTemplate(TemplateQueryCO co) {
        TemplateQueryEntity templateQueryEntity = TemplateFactoryMapper.INSTANCE.queryCOToQueryEntity(co);
        TemplateEntity templateEntity = templateRepository.get(templateQueryEntity);
        TemplateGetVO templateVO = TemplateFactoryMapper.INSTANCE.entityToGetVO(templateEntity);
        return templateVO;
    }

    @Override
    public Integer insertTemplate(TemplateCO co) {
        TemplateEntity templateEntity = TemplateFactoryMapper.INSTANCE.coToEntity(co);
        Integer number = templateRepository.insert(templateEntity);
        return number;
    }

    @Override
    public Integer modifyTemplate(TemplateCO co) {
        TemplateEntity templateEntity = TemplateFactoryMapper.INSTANCE.coToEntity(co);
        Integer number = templateRepository.modify(templateEntity);
        return number;
    }

    @Override
    public Integer deleteTemplate(TemplateCO co) {
        Long id = co.getId();
        Integer number = templateRepository.delete(id);
        return number;
    }
}
